<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Data' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Données
      </span>
    </div>
    <div>
      <div class="top">
        <b-row>
          <b-col class="left-col">
            <span>
              <img
                src="@/assets/icons/files_ressources.svg"
                alt="Icône ressources"
              />
              {{ datasetsCount }} jeu{{ datasetsCount > 1 ? 'x' : '' }} de données
            </span>
            <div
              class="add-btn"
              @click="$router.push({ name: 'AddDataset' })"
            >
              <b-icon-plus />
              Nouveau jeu de données
            </div>
            <SearchTable
              :placeholder="'Rechercher un jeu de données'"
              :searchFunction="SEARCH_DATASETS_LIST"
              @loading="loadSearch"
            />
          </b-col>
          <b-col class="right-col">

          </b-col>
        </b-row>
      </div>
      <div class="custom-table">
        <b-overlay
          :show="loading"
          :variant="'white'"
          :opacity="0.7"
          :blur="'2px'"
          rounded="sm"
        >
          <CustomTable
            :routeTo="'DatasetDetail'"
            :fields="fields"
            :items="items"
            :sortFunction="GET_DATASETS_LIST"
            :selectable="false"
            :allowDuplication="true"
            @sorted="setTableSorted"
            @access="goToDatasetPermissions"
            @duplicate="duplicateDataset"
            @delete="openDeleteModal"
            @loading="setTableLoader"
          />
          <Pagination
            v-if="Math.ceil(datasetsCount/50) > 1"
            :nbPages="Math.ceil(datasetsCount/50)"
            @change-page="changeTablePage"
          />
        </b-overlay>
      </div>
    </div>
    <DeleteDataset
      :open="deletingDataset"
      :dataset="datasetToDelete"
      @hide="deletingDataset = false"
      @update="updateDatasetsList"
    />
  </div>
</template>

<script>
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import DeleteDataset from '@/components/Modals/DeleteDataset.vue';
import SearchTable from '@/components/SearchTable.vue';

import { mapState, mapMutations, mapActions } from 'vuex';

export default {
  name: 'Datasets',

  components: {
    CustomTable,
    Pagination,
    DeleteDataset,
    SearchTable
  },

  data() {
    return {
      loading: false,
      fields: [
        {
          key: 'Nom',
          apiName: 'display_name',
          sortable: true,
          width: '22%',
          centered: false
        },
        {
          key: 'Organisation',
          apiName: 'usergroup',
          sortable: true,
          width: '13%',
          centered: false
        },
        {
          key: 'Création',
          apiName: 'creation_date',
          sortable: true,
          width: '9%',
          centered: true
        },
        {
          key: 'Dernière révision',
          apiName: 'last_revision_date',
          sortable: true,
          width: '12%',
          centered: true
        },
        // {
        //   key: 'Data rattaché',
        //   sortable: false,
        //   width: '',
        //   centered: true
        // },
        {
          key: 'Ressource principale',
          sortable: false,
          width: '12%',
          centered: false
        },
        {
          key: 'Nombre d\'annexes',
          sortable: false,
          width: '10%',
          centered: true
        },
        {
          key: 'Accès',
          sortable: false,
          width: '5%',
          centered: true
        },
        {
          key: 'Dupliquer',
          sortable: false,
          width: '7%',
          centered: true
        },
        {
          key: 'Supprimer',
          sortable: false,
          width: '7%',
          centered: true
        }
      ],
      tableSorted: {
        direction: null,
        field: null
      },
      deletingDataset: false,
      datasetToDelete: null
    };
  },

  computed: {
    ...mapState('datasets', [
      'datasetsList',
      'datasetsCount',
      'isDatasetsListSearched'
    ]),
    ...mapState('pagination', [
      'currentPage'
    ]),

    items() {
      return this.datasetsList.map(el => {
        return {
          id: el.id,
          'Nom': el.display_name,
          'Organisation': el.usergroup.display_name,
          'Date de création': new Date(el.creation_date).toLocaleString('fr-FR', {year: "2-digit", month: "2-digit", day: "2-digit"}),
          'Date de dernière révision':
            el.last_revision_date ? new Date(el.last_revision_date).toLocaleString('fr-FR', {year: "2-digit", month: "2-digit", day: "2-digit"}) : '',
          // 'Data rattaché': '',
          'Ressource principale': el.resource_source ? el.resource_source.display_name : el.resource_data ? el.resource_data.display_name : '',
          'Nombre d\'annexes': el.resource_annex ? el.resource_annex.length : '0',
          'Accès': el.default_permission_level
        }
      });
    }
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
      if (from.name === 'DatasetPermissions') {
        vm.RESET_USERGROUPS_PERMISSIONS_FILTERS('usergroup_type_id');
        vm.RESET_USERGROUPS_PERMISSIONS_FILTERS('organisation_type_id');
        vm.RESET_USERGROUPS_PERMISSIONS_FILTERS('level');
      }
    });
  },

  created() {
    if (!this.isDatasetsListSearched) {
      this.getData(this.currentPage);
    }
    // Clean stored form
    this.SET_CURRENT_FORM({
      id: null,
      form: null
    });
  },

  methods: {
    ...mapMutations('form', [
      'SET_CURRENT_FORM'
    ]),
    ...mapMutations('datasets', [
      'RESET_USERGROUPS_PERMISSIONS_FILTERS'
    ]),
    ...mapActions('datasets', [
      'GET_DATASETS_LIST',
      'SEARCH_DATASETS_LIST',
      'DUPLICATE_DATASET'
    ]),

    getData(page) {
      this.loading = true;
      this.GET_DATASETS_LIST({...this.tableSorted, page: page})
      .then(() => {
        this.loading = false;
      });
    },

    changeTablePage(e) {
      this.getData(e);
    },

    loadSearch(e) {
      this.loading = e;
    },

    setTableLoader(e) {
      this.loading = e;
    },

    setTableSorted(e) {
      this.tableSorted = e;
    },

    duplicateDataset(e) {
      this.loading = true;
      this.DUPLICATE_DATASET(e.id)
        .then(() => {
          this.$router.push({
            name: 'AddDataset'
          })
            .then(() => {
              this.loading = false;
            })
            .catch(() => {
              this.loading = false;
            });
        })
        .catch(() => {
          this.loading = false;
        })
    },

    openDeleteModal(e) {
      this.deletingDataset = true;
      this.datasetToDelete = e;
    },

    updateDatasetsList() {
      this.getData();
    },

    goToDatasetPermissions(e) {
      this.$router.push({
        name: 'DatasetPermissions',
        params: {
          id: e,
          datasetName: this.datasetsList.find(el => el.id === e).display_name
        }
      });
    }
  }
}
</script>
